import pytest
from my_list import MyList


def test_append():
    test_list = MyList()
    assert len(test_list) == 0
    test_list.append(7)
    test_list.append(8)
    assert len(test_list) == 2


@pytest.mark.benchmark(group="append")
def test_benchmark_append(benchmark):
    test_list = MyList()
    benchmark(test_list.append, 7)


@pytest.mark.benchmark(group="append")
def test_benchmark_append_improved(benchmark):
    def setup():
        return (MyList(), 7), {}
    benchmark.pedantic(MyList.append, setup=setup)


@pytest.mark.benchmark(group="insert")
def test_benchmark_insert_improved(benchmark):
    def setup():
        return (MyList(), 0, 7), {}
    benchmark.pedantic(MyList.insert, setup=setup)


@pytest.mark.benchmark(group="insert")
def test_benchmark_insert(benchmark):
    test_list = MyList()
    benchmark(lambda x: test_list.insert(0, x), 7)
